Foreman - Bug #15285

Timezone is saved as an empty string instead of nil after changing to a timezone and back to
"Browser timezone"

06/03/2016 11:33 AM - Walden Raines
ull/3886
Description

It appears as if when saving a user as "Browser Timezone" after changing the timezone to something other than "Browser Timezone"
that the value is saved as an empty string instead of nil.

Check it out:

katello=# select count(id) from users where timezone =";
count

(byebug) cookies[:timezone]
"America/New_York"
(byebug) User.current.try(:timezone)

Which will obviously cause this time zone code [1]:

client_timezone = User.current.try(:timezone) || cookies[:timezone]
Time.zone = client_timezone if client_timezone.present?

to not set the correct timezone since User.current.try(:timezone) will be true and thus client_timezone.present? will be false.
Steps to Reproduce

1. Change a user's timezone to something other than "Browser timezone"

2. Change the same user's timezone back to "Browser timezone"

3. Note that user.timezone is an empty string

[1] https://github.com/theforeman/foreman/blob/develop/app/controllers/concerns/application_shared.rb#l 9-1.13

History

#1 - 06/03/2016 11:34 AM - Walden Raines

- Subject changed from Timezone is saved as an empty string instead of nil to Timezone is saved as an empty string instead of nil after changing to a
timezone and back to "Browser timezone"

#2 - 06/03/2016 12:07 PM - Walden Raines
- Bugzilla link set to 1342603

#3 - 09/25/2016 10:47 AM - The Foreman Bot
- Status changed from New to Ready For Testing

05/22/2024 1/2



https://github.com/theforeman/foreman/blob/develop/app/controllers/concerns/application_shared.rb#L9-L13

- Assignee set to Shlomi Zadok

- Pull request https://github.com/theforeman/foreman/pull/3886 added

#4 - 09/25/2016 10:51 AM - Shlomi Zadok

- Target version set to 1.5.3

#5 - 09/26/2016 07:32 AM - Shlomi Zadok
- Status changed from Ready For Testing to Rejected
- Target version deleted (1.5.3)

Please see discussion at https:/github.com/theforeman/foreman/pull/3886
Feel free to re-open the pull request and the issue should you think we're are wrong.

#6 - 09/26/2016 07:41 AM - Dominic Cleal
- Status changed from Rejected to New

- Assignee deleted (Shlomi Zadok)

| think this issue is still valid, the code that is given in the description (from application_shared) is still present and has the fault described. If the DB
timezone is set to an empty string instead of nil, fallback to the cookie timezone doesn't occur.

It appears that the approach in the PR of storing the cookie in the DB on each request was rejected, not that the bug described here is rejected.

There's no need to store the cookie in the DB to fix this, only to ignore empty strings in the DB too.
